--- operations/workshop/external/ff-save.c.orig	2013-10-15 16:41:03.000000000 -0700
+++ operations/workshop/external/ff-save.c	2013-10-15 16:41:16.000000000 -0700
@@ -568,7 +568,7 @@
     }
 
   /* open the codec */
-  if (avcodec_open (c, codec) < 0)
+  if (avcodec_open2 (c, codec, NULL) < 0)
     {
       fprintf (stderr, "could not open codec\n");
       exit (1);
@@ -769,26 +769,24 @@
      /*XXX: FOO p->audio_st = add_audio_stream (op, p->oc, p->fmt->audio_codec);*/
     }
 
-  if (av_set_parameters (p->oc, NULL) < 0)
-    {
-      fprintf (stderr, "Invalid output format propeters\n%s", "");
-      return -1;
-    }
-
-  dump_format (p->oc, 0, self->path, 1);
+  av_dump_format (p->oc, 0, self->path, 1);
 
   if (p->video_st)
     open_video (p, p->oc, p->video_st);
   if (p->audio_st)
     open_audio (p, p->oc, p->audio_st);
 
-  if (url_fopen (&p->oc->pb, self->path, URL_WRONLY) < 0)
+  if (avio_open (&p->oc->pb, self->path, AVIO_FLAG_WRITE) < 0)
     {
       fprintf (stderr, "couldn't open '%s'\n", self->path);
       return -1;
     }
 
-  av_write_header (p->oc);
+  if (avformat_write_header (p->oc, NULL) < 0)
+     {
+        fprintf(stderr, "Error occurred when opening output file\n");
+        return 1;
+     }
 
   return 0;
 }
@@ -858,7 +856,7 @@
             av_freep (&p->oc->streams[i]);
           }
 
-        url_fclose (&p->oc->pb);
+        avio_close (p->oc->pb);
         free (p->oc);
       }
       g_free (o->chant_data);
From 97067622352e58f86a24851dacb1f5daa0762897 Mon Sep 17 00:00:00 2001
From: nick black <nick.black@sprezzatech.com>
Date: Thu, 13 Dec 2012 23:11:16 -0500
Subject: port gegl forward to libav 54


diff --git a/operations/external/ff-load.c b/operations/external/ff-load.c
index 442ec5f..75d26e9 100644
--- operations/external/ff-load.c
+++ operations/external/ff-load.c
@@ -137,7 +137,7 @@ ff_cleanup (GeglChantO *o)
       if (p->enc)
         avcodec_close (p->enc);
       if (p->ic)
-        av_close_input_file (p->ic);
+        avformat_close_input(&p->ic);
       if (p->lavc_frame)
         av_free (p->lavc_frame);
 
@@ -216,9 +216,9 @@ decode_frame (GeglOperation *operation,
             {
               do
                 {
-                  if (av_read_packet (p->ic, &p->pkt) < 0)
+                  if (av_read_frame (p->ic, &p->pkt) < 0)
                     {
-                      fprintf (stderr, "av_read_packet failed for %s\n",
+                      fprintf (stderr, "av_read_frame failed for %s\n",
                                o->path);
                       return -1;
                     }
@@ -271,12 +271,12 @@ prepare (GeglOperation *operation)
       gint err;
 
       ff_cleanup (o);
-      err = av_open_input_file (&p->ic, o->path, NULL, 0, NULL);
+      err = avformat_open_input(&p->ic, o->path, NULL, 0);
       if (err < 0)
         {
           print_error (o->path, err);
         }
-      err = av_find_stream_info (p->ic);
+      err = avformat_find_stream_info (p->ic, NULL);
       if (err < 0)
         {
           g_warning ("ff-load: error finding stream info for %s", o->path);
@@ -312,7 +312,7 @@ prepare (GeglOperation *operation)
       if (p->codec->capabilities & CODEC_CAP_TRUNCATED)
         p->enc->flags |= CODEC_FLAG_TRUNCATED;
 
-      if (avcodec_open (p->enc, p->codec) < 0)
+      if (avcodec_open2 (p->enc, p->codec, NULL) < 0)
         {
           g_warning ("error opening codec %s", p->enc->codec->name);
           return;
-- 
cgit v0.10.1


--- operations/workshop/external/ff-save.c.orig	2014-09-18 12:53:29.000000000 -0700
+++ operations/workshop/external/ff-save.c	2014-09-18 12:56:01.000000000 -0700
@@ -358,7 +358,7 @@
   AVStream *st;
 
   p = NULL;
-  st = av_new_stream (oc, 1);
+  st = avformat_new_stream (oc, 1);
   if (!st)
     {
       fprintf (stderr, "Could not alloc stream\n");
@@ -487,7 +487,7 @@
   AVCodecContext *c;
   AVStream *st;
 
-  st = av_new_stream (oc, 0);
+  st = avformat_new_stream (oc, 0);
   if (!st)
     {
       fprintf (stderr, "Could not alloc stream %p %p %i\n", op, oc, codec_id);
--- operations/workshop/external/ff-save.c.orig	2016-02-21 07:46:59.000000000 -0800
+++ operations/workshop/external/ff-save.c	2016-02-21 07:51:06.000000000 -0800
@@ -410,10 +410,10 @@
       p->audio_input_frame_size = p->audio_outbuf_size / c->channels;
       switch (st->codec->codec_id)
         {
-        case CODEC_ID_PCM_S16LE:
-        case CODEC_ID_PCM_S16BE:
-        case CODEC_ID_PCM_U16LE:
-        case CODEC_ID_PCM_U16BE:
+        case AV_CODEC_ID_PCM_S16LE:
+        case AV_CODEC_ID_PCM_S16BE:
+        case AV_CODEC_ID_PCM_U16LE:
+        case AV_CODEC_ID_PCM_U16BE:
           p->audio_input_frame_size >>= 1;
           break;
         default:
@@ -513,11 +513,11 @@
         c->frame_rate=op->fps;
         c->frame_rate_base=1;
     #endif
-     c->pix_fmt = PIX_FMT_YUV420P;
+     c->pix_fmt = AV_PIX_FMT_YUV420P;
 
 
   c->gop_size = 12;             /* emit one intra frame every twelve frames at most */
-  if (c->codec_id == CODEC_ID_MPEG2VIDEO)
+  if (c->codec_id == AV_CODEC_ID_MPEG2VIDEO)
     {
       /* just for testing, we also add B frames */
       /*c->max_b_frames = 2;*/
@@ -595,9 +595,9 @@
      picture is needed too. It is then converted to the required
      output format */
   p->tmp_picture = NULL;
-  if (c->pix_fmt != PIX_FMT_RGB24)
+  if (c->pix_fmt != AV_PIX_FMT_RGB24)
     {
-      p->tmp_picture = alloc_picture (PIX_FMT_RGB24, c->width, c->height);
+      p->tmp_picture = alloc_picture (AV_PIX_FMT_RGB24, c->width, c->height);
       if (!p->tmp_picture)
         {
           fprintf (stderr, "Could not allocate temporary picture\n");
@@ -648,7 +648,7 @@
 
   c = st->codec;
 
-  if (c->pix_fmt != PIX_FMT_RGB24)
+  if (c->pix_fmt != AV_PIX_FMT_RGB24)
     {
       struct SwsContext *img_convert_ctx;
 
@@ -658,7 +658,7 @@
                       c->height);
 
       img_convert_ctx = sws_getContext(c->width, c->height, c->pix_fmt,
-                                       c->width, c->height, PIX_FMT_RGB24,
+                                       c->width, c->height, AV_PIX_FMT_RGB24,
                                        SWS_BICUBIC, NULL, NULL, NULL);
 
       if (img_convert_ctx == NULL)
@@ -760,11 +760,11 @@
   p->video_st = NULL;
   p->audio_st = NULL;
 
-  if (p->fmt->video_codec != CODEC_ID_NONE)
+  if (p->fmt->video_codec != AV_CODEC_ID_NONE)
     {
       p->video_st = add_video_stream (self, p->oc, p->fmt->video_codec);
     }
-  if (p->oxide_audio_query && p->fmt->audio_codec != CODEC_ID_NONE)
+  if (p->oxide_audio_query && p->fmt->audio_codec != AV_CODEC_ID_NONE)
     {
      /*XXX: FOO p->audio_st = add_audio_stream (op, p->oc, p->fmt->audio_codec);*/
     }
--- operations/external/ff-load.c.orig	2016-05-02 05:14:09.000000000 -0700
+++ operations/external/ff-load.c	2016-05-02 05:17:28.000000000 -0700
@@ -321,7 +321,7 @@
       p->width = p->enc->width;
       p->height = p->enc->height;
       p->frames = 10000000;
-      p->lavc_frame = avcodec_alloc_frame ();
+      p->lavc_frame = av_frame_alloc ();
 
       if (p->fourcc)
         g_free (p->fourcc);
--- operations/workshop/external/ff-save.c.orig	2016-05-02 05:14:32.000000000 -0700
+++ operations/workshop/external/ff-save.c	2016-05-02 05:15:58.000000000 -0700
@@ -537,7 +537,7 @@
   uint8_t  *picture_buf;
   int       size;
 
-  picture = avcodec_alloc_frame ();
+  picture = av_frame_alloc ();
   if (!picture)
     return NULL;
   size = avpicture_get_size (pix_fmt, width, height);
